#ifndef POPULATION_H
#define POPULATION_H

#include "Individual.h"
using namespace std;

class Population
{
private:
	vector<Individual> population;						// Holds individuals
	double meanAge;										// Average age in generations of the population
	static const int defaultMaxSize = 1000;				// Default size
	
public:
	Population();										// Default constructor creates random size population up to defaultMaxSize
	Population(int);									// Constructor uses specified size
	~Population();										// Destructor
	Population& operator!();							// Mutates the population; returns self, which is now a new population
	bool solutionExists(double _tolerance = 0.0005f);	// Checks if the solution exists (within tolerance) in the current generation; use for termination
	int getSize();										// Returns size
	double getMeanAge();								// Returns average age of the population
	void printPop();									// Print the population
};

#endif